searchData={"items":[{"type":"module","title":"ExEcrime","doc":"Facade module for the eCrime API client. Provides a single entry point\nfor all API operations by delegating to specialized modules.","ref":"ExEcrime.html"},{"type":"function","title":"ExEcrime.add_comment/3","doc":"Adds a comment to an event. See `ExEcrime.Events.add_comment/3` for details.","ref":"ExEcrime.html#add_comment/3"},{"type":"function","title":"ExEcrime.delete_comment/2","doc":"Deletes a comment from an event. See `ExEcrime.Events.delete_comment/2` for details.","ref":"ExEcrime.html#delete_comment/2"},{"type":"function","title":"ExEcrime.download_screenshot/2","doc":"Downloads a screenshot. See `ExEcrime.Screenshots.download_screenshot/2` for details.","ref":"ExEcrime.html#download_screenshot/2"},{"type":"function","title":"ExEcrime.download_screenshot_version/3","doc":"Downloads a screenshot version. See `ExEcrime.Screenshots.download_screenshot_version/3` for details.","ref":"ExEcrime.html#download_screenshot_version/3"},{"type":"function","title":"ExEcrime.events_with_status/4","doc":"Lists events by status. See `ExEcrime.Events.events_with_status/4` for details.","ref":"ExEcrime.html#events_with_status/4"},{"type":"function","title":"ExEcrime.list_actors/1","doc":"Lists actors. See `ExEcrime.Actors.list_actors/1` for details.","ref":"ExEcrime.html#list_actors/1"},{"type":"function","title":"ExEcrime.list_events/3","doc":"Lists events. See `ExEcrime.Events.list_events/3` for details.","ref":"ExEcrime.html#list_events/3"},{"type":"function","title":"ExEcrime.list_leaksites/1","doc":"Lists leaksites. See `ExEcrime.Leaksites.list_leaksites/1` for details.","ref":"ExEcrime.html#list_leaksites/1"},{"type":"function","title":"ExEcrime.list_online_leaksites/1","doc":"Lists online leaksites. See `ExEcrime.Leaksites.list_online_leaksites/1` for details.","ref":"ExEcrime.html#list_online_leaksites/1"},{"type":"function","title":"ExEcrime.list_screenshots/1","doc":"Lists screenshots. See `ExEcrime.Screenshots.list_screenshots/1` for details.","ref":"ExEcrime.html#list_screenshots/1"},{"type":"function","title":"ExEcrime.login/1","doc":"Performs login authentication. See `ExEcrime.Client.login/1` for details.","ref":"ExEcrime.html#login/1"},{"type":"function","title":"ExEcrime.new/0","doc":"Creates a new client instance. See `ExEcrime.Client.new/0` for details.","ref":"ExEcrime.html#new/0"},{"type":"function","title":"ExEcrime.search_actors/2","doc":"Searches actors. See `ExEcrime.Actors.search_actors/2` for details.","ref":"ExEcrime.html#search_actors/2"},{"type":"function","title":"ExEcrime.search_events/4","doc":"Searches events. See `ExEcrime.Events.search_events/4` for details.","ref":"ExEcrime.html#search_events/4"},{"type":"function","title":"ExEcrime.search_history/2","doc":"Searches event history. See `ExEcrime.Events.search_history/2` for details.","ref":"ExEcrime.html#search_history/2"},{"type":"function","title":"ExEcrime.search_leaksites/2","doc":"Searches leaksites. See `ExEcrime.Leaksites.search_leaksites/2` for details.","ref":"ExEcrime.html#search_leaksites/2"},{"type":"function","title":"ExEcrime.view_actor/2","doc":"Views an actor. See `ExEcrime.Actors.view_actor/2` for details.","ref":"ExEcrime.html#view_actor/2"},{"type":"function","title":"ExEcrime.view_event/2","doc":"Views an event. See `ExEcrime.Events.view_event/2` for details.","ref":"ExEcrime.html#view_event/2"},{"type":"function","title":"ExEcrime.view_screenshot_history/2","doc":"Views screenshot history. See `ExEcrime.Screenshots.view_screenshot_history/2` for details.","ref":"ExEcrime.html#view_screenshot_history/2"},{"type":"module","title":"ExEcrime.Actors","doc":"Module for managing actors in the eCrime API.","ref":"ExEcrime.Actors.html"},{"type":"function","title":"ExEcrime.Actors.list_actors/1","doc":"Lists all actors.","ref":"ExEcrime.Actors.html#list_actors/1"},{"type":"function","title":"Examples - ExEcrime.Actors.list_actors/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Actors.list_actors(client)\n    [%{\"id\" => \"123\", \"name\" => \"Actor Name\"}]","ref":"ExEcrime.Actors.html#list_actors/1-examples"},{"type":"function","title":"ExEcrime.Actors.search_actors/2","doc":"Searches actors by query.","ref":"ExEcrime.Actors.html#search_actors/2"},{"type":"function","title":"Examples - ExEcrime.Actors.search_actors/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Actors.search_actors(client, \"ransomware\")\n    [%{\"id\" => \"123\", \"name\" => \"Actor Name\"}]","ref":"ExEcrime.Actors.html#search_actors/2-examples"},{"type":"function","title":"ExEcrime.Actors.view_actor/2","doc":"Views details of a specific actor.","ref":"ExEcrime.Actors.html#view_actor/2"},{"type":"function","title":"Examples - ExEcrime.Actors.view_actor/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Actors.view_actor(client, \"123\")\n    %{\"id\" => \"123\", \"name\" => \"Actor Name\"}","ref":"ExEcrime.Actors.html#view_actor/2-examples"},{"type":"module","title":"ExEcrime.Client","doc":"Base client module for interacting with the eCrime API.\nHandles API key configuration and client instantiation.","ref":"ExEcrime.Client.html"},{"type":"function","title":"ExEcrime.Client.auth_headers/1","doc":"Returns authentication headers for API requests.","ref":"ExEcrime.Client.html#auth_headers/1"},{"type":"function","title":"Examples - ExEcrime.Client.auth_headers/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Client.auth_headers(client)\n    %{\"X-API-Key\" => \"test_key\"}","ref":"ExEcrime.Client.html#auth_headers/1-examples"},{"type":"function","title":"ExEcrime.Client.login/1","doc":"Performs login authentication with the eCrime API.\n\nReturns the response body if status is 200, otherwise returns the full response.","ref":"ExEcrime.Client.html#login/1"},{"type":"function","title":"Examples - ExEcrime.Client.login/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Client.login(client)\n    %{\"status\" => \"authenticated\"}  # Assuming this is the API response","ref":"ExEcrime.Client.html#login/1-examples"},{"type":"function","title":"ExEcrime.Client.new/0","doc":"Creates a new client instance using the API key from the ECRIME_API_KEY environment variable.\nRaises an error if the environment variable is not set.","ref":"ExEcrime.Client.html#new/0"},{"type":"function","title":"Examples - ExEcrime.Client.new/0","doc":"iex> System.put_env(\"ECRIME_API_KEY\", \"test_key\")\n    iex> client = ExEcrime.Client.new()\n    iex> client.api_key\n    \"test_key\"\n\n    iex> System.delete_env(\"ECRIME_API_KEY\")\n    iex> ExEcrime.Client.new()\n    ** (RuntimeError) Expected ECRIME_API_KEY environment variable to be set","ref":"ExEcrime.Client.html#new/0-examples"},{"type":"module","title":"ExEcrime.Events","doc":"Module for managing events in the eCrime API.","ref":"ExEcrime.Events.html"},{"type":"function","title":"ExEcrime.Events.add_comment/3","doc":"Adds a comment to an event.","ref":"ExEcrime.Events.html#add_comment/3"},{"type":"function","title":"Examples - ExEcrime.Events.add_comment/3","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.add_comment(client, \"123\", \"Test comment\")\n    %{\"status\" => \"comment_added\"}  # Assuming this is the API response","ref":"ExEcrime.Events.html#add_comment/3-examples"},{"type":"function","title":"ExEcrime.Events.delete_comment/2","doc":"Deletes a comment from an event.","ref":"ExEcrime.Events.html#delete_comment/2"},{"type":"function","title":"Examples - ExEcrime.Events.delete_comment/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.delete_comment(client, \"123\")\n    %{\"status\" => \"comment_deleted\"}","ref":"ExEcrime.Events.html#delete_comment/2-examples"},{"type":"function","title":"ExEcrime.Events.events_with_status/4","doc":"Lists events with a specific status, optionally filtered by date range.","ref":"ExEcrime.Events.html#events_with_status/4"},{"type":"function","title":"Examples - ExEcrime.Events.events_with_status/4","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.events_with_status(client, \"active\")\n    [%{\"id\" => \"123\", \"status\" => \"active\"}]\n\n    iex> ExEcrime.Events.events_with_status(client, \"active\", \"2023-01-01\", \"2023-12-31\")\n    [%{\"id\" => \"123\", \"status\" => \"active\"}]","ref":"ExEcrime.Events.html#events_with_status/4-examples"},{"type":"function","title":"ExEcrime.Events.list_events/3","doc":"Lists all events, optionally filtered by date range.","ref":"ExEcrime.Events.html#list_events/3"},{"type":"function","title":"Examples - ExEcrime.Events.list_events/3","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.list_events(client)\n    [%{\"id\" => \"123\"}]\n\n    iex> ExEcrime.Events.list_events(client, \"2023-01-01\", \"2023-12-31\")\n    [%{\"id\" => \"123\"}]","ref":"ExEcrime.Events.html#list_events/3-examples"},{"type":"function","title":"ExEcrime.Events.search_events/4","doc":"Searches events by query, optionally filtered by date range.","ref":"ExEcrime.Events.html#search_events/4"},{"type":"function","title":"Examples - ExEcrime.Events.search_events/4","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.search_events(client, \"ransomware\")\n    [%{\"id\" => \"123\", \"type\" => \"ransomware\"}]","ref":"ExEcrime.Events.html#search_events/4-examples"},{"type":"function","title":"ExEcrime.Events.search_history/2","doc":"Searches event history by query.","ref":"ExEcrime.Events.html#search_history/2"},{"type":"function","title":"Examples - ExEcrime.Events.search_history/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.search_history(client, \"ransomware\")\n    [%{\"event_id\" => \"123\", \"action\" => \"created\"}]","ref":"ExEcrime.Events.html#search_history/2-examples"},{"type":"function","title":"ExEcrime.Events.view_event/2","doc":"Views details of a specific event.","ref":"ExEcrime.Events.html#view_event/2"},{"type":"function","title":"Examples - ExEcrime.Events.view_event/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Events.view_event(client, \"123\")\n    %{\"id\" => \"123\", \"title\" => \"Event Title\"}","ref":"ExEcrime.Events.html#view_event/2-examples"},{"type":"module","title":"ExEcrime.Leaksites","doc":"Module for managing leaksites in the eCrime API.","ref":"ExEcrime.Leaksites.html"},{"type":"function","title":"ExEcrime.Leaksites.list_leaksites/1","doc":"Lists all leaksites.","ref":"ExEcrime.Leaksites.html#list_leaksites/1"},{"type":"function","title":"Examples - ExEcrime.Leaksites.list_leaksites/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Leaksites.list_leaksites(client)\n    [%{\"id\" => \"1\", \"url\" => \"example.onion\"}]","ref":"ExEcrime.Leaksites.html#list_leaksites/1-examples"},{"type":"function","title":"ExEcrime.Leaksites.list_online_leaksites/1","doc":"Lists only online leaksites.","ref":"ExEcrime.Leaksites.html#list_online_leaksites/1"},{"type":"function","title":"Examples - ExEcrime.Leaksites.list_online_leaksites/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Leaksites.list_online_leaksites(client)\n    [%{\"id\" => \"1\", \"url\" => \"example.onion\", \"status\" => \"online\"}]","ref":"ExEcrime.Leaksites.html#list_online_leaksites/1-examples"},{"type":"function","title":"ExEcrime.Leaksites.search_leaksites/2","doc":"Searches leaksites by query.","ref":"ExEcrime.Leaksites.html#search_leaksites/2"},{"type":"function","title":"Examples - ExEcrime.Leaksites.search_leaksites/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Leaksites.search_leaksites(client, \"ransomware\")\n    [%{\"id\" => \"1\", \"url\" => \"example.onion\"}]","ref":"ExEcrime.Leaksites.html#search_leaksites/2-examples"},{"type":"module","title":"ExEcrime.Screenshots","doc":"Module for managing screenshots in the eCrime API.","ref":"ExEcrime.Screenshots.html"},{"type":"function","title":"ExEcrime.Screenshots.download_screenshot/2","doc":"Downloads the latest version of a screenshot.","ref":"ExEcrime.Screenshots.html#download_screenshot/2"},{"type":"function","title":"Examples - ExEcrime.Screenshots.download_screenshot/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Screenshots.download_screenshot(client, \"screen.jpg\")\n    < >","ref":"ExEcrime.Screenshots.html#download_screenshot/2-examples"},{"type":"function","title":"ExEcrime.Screenshots.download_screenshot_version/3","doc":"Downloads a specific version of a screenshot.","ref":"ExEcrime.Screenshots.html#download_screenshot_version/3"},{"type":"function","title":"Examples - ExEcrime.Screenshots.download_screenshot_version/3","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Screenshots.download_screenshot_version(client, \"screen.jpg\", \"1\")\n    < >  # Returns binary data of the screenshot","ref":"ExEcrime.Screenshots.html#download_screenshot_version/3-examples"},{"type":"function","title":"ExEcrime.Screenshots.list_screenshots/1","doc":"Lists all screenshots.","ref":"ExEcrime.Screenshots.html#list_screenshots/1"},{"type":"function","title":"Examples - ExEcrime.Screenshots.list_screenshots/1","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Screenshots.list_screenshots(client)\n    [%{\"filename\" => \"screen.jpg\", \"version\" => \"1\"}]","ref":"ExEcrime.Screenshots.html#list_screenshots/1-examples"},{"type":"function","title":"ExEcrime.Screenshots.view_screenshot_history/2","doc":"Views the history of a screenshot.","ref":"ExEcrime.Screenshots.html#view_screenshot_history/2"},{"type":"function","title":"Examples - ExEcrime.Screenshots.view_screenshot_history/2","doc":"iex> client = ExEcrime.Client.new()\n    iex> ExEcrime.Screenshots.view_screenshot_history(client, \"screen.jpg\")\n    [%{\"version\" => \"1\", \"timestamp\" => \"2023-01-01\"}]","ref":"ExEcrime.Screenshots.html#view_screenshot_history/2-examples"},{"type":"extras","title":"ExEcrime","doc":"# ExEcrime\n\nAn Elixir client library for interacting with the eCrime API (https://ecrime.ch/api/v1). This library provides a convenient interface for managing events, leaksites, screenshots, and actors through the API.","ref":"readme.html"},{"type":"extras","title":"Installation - ExEcrime","doc":"Add `ex_ecrime` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_ecrime, \"~> 0.1.0\"},\n    {:req, \"~> 0.3.0\"}  # Required HTTP client dependency\n  ]\nend\n```\n\nThen run:\n\n```bash\n$ mix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - ExEcrime","doc":"The library requires an API key to be set in the environment variable `ECRIME_API_KEY`. You can set this in your shell:\n\n```bash\nexport ECRIME_API_KEY=\"your-api-key-here\"\n```\n\nOr in your `config/config.exs`:\n\n```elixir\nconfig :ex_ecrime,\n  api_key: \"your-api-key-here\"\n```\n\nIf using the config file approach, update the `ExEcrime.Client.new/0` function to read from the config if the environment variable isn't set.","ref":"readme.html#configuration"},{"type":"extras","title":"Usage - ExEcrime","doc":"The library is organized into modules based on functionality:\n\n- `ExEcrime.Client` - Client setup and authentication\n- `ExEcrime.Events` - Event management\n- `ExEcrime.Leaksites` - Leaksite operations\n- `ExEcrime.Screenshots` - Screenshot management\n- `ExEcrime.Actors` - Actor information\n- `ExEcrime` - Optional facade module with all functions","ref":"readme.html#usage"},{"type":"extras","title":"Basic Example - ExEcrime","doc":"```elixir\n# Create a new client\nclient = ExEcrime.Client.new()\n\n# Login\nExEcrime.Client.login(client)\n\n# List all events\nevents = ExEcrime.Events.list_events(client)\n\n# Search for ransomware events\nransomware_events = ExEcrime.Events.search_events(client, \"ransomware\")\n\n# List online leaksites\nonline_leaksites = ExEcrime.Leaksites.list_online_leaksites(client)\n\n# Download a screenshot\nscreenshot = ExEcrime.Screenshots.download_screenshot(client, \"screen.jpg\")\n\n# View an actor\nactor = ExEcrime.Actors.view_actor(client, \"123\")\n```","ref":"readme.html#basic-example"},{"type":"extras","title":"Using the Facade Module - ExEcrime","doc":"If you prefer a single module interface:\n\n```elixir\nclient = ExEcrime.new()\nExEcrime.list_events(client)\nExEcrime.search_events(client, \"ransomware\")\nExEcrime.list_online_leaksites(client)\nExEcrime.download_screenshot(client, \"screen.jpg\")\nExEcrime.view_actor(client, \"123\")\n```","ref":"readme.html#using-the-facade-module"},{"type":"extras","title":"Error Handling - ExEcrime","doc":"API calls return the response body directly on HTTP 200 status. For other status codes, the full `Req.Response` struct is returned, allowing you to handle errors:\n\n```elixir\ncase ExEcrime.Events.view_event(client, \"nonexistent-id\") do\n  %Req.Response{status: status} = response ->\n    IO.puts(\"Error #{status}: #{inspect(response.body)}\")\n  body ->\n    IO.puts(\"Success: #{inspect(body)}\")\nend\n```","ref":"readme.html#error-handling"},{"type":"extras","title":"Features - ExEcrime","doc":"#### Events\n- Add/delete comments\n- View events\n- List events by status or date range\n- Search events and history\n\n#### Leaksites\n- List all or online leaksites\n- Search leaksites\n\n#### Screenshots\n- Download screenshots (latest or specific version)\n- List screenshots\n- View screenshot history\n\n#### Actors\n- View actor details\n- List actors\n- Search actors","ref":"readme.html#features"},{"type":"extras","title":"Documentation - ExEcrime","doc":"Full documentation is available in the code using Elixir's `@doc` attributes. You can generate HTML documentation with:\n\n```bash\n$ mix docs\n```","ref":"readme.html#documentation"},{"type":"extras","title":"Development - ExEcrime","doc":"To work on the library:\n\n1. Clone the repository\n2. Install dependencies: `mix deps.get`\n3. Compile: `mix compile`\n4. Run tests: `mix test` (after adding tests)","ref":"readme.html#development"},{"type":"extras","title":"Contributing - ExEcrime","doc":"1. Fork the repository\n2. Create your feature branch (`git checkout -b feature/amazing-feature`)\n3. Commit your changes (`git commit -am 'Add amazing feature'`)\n4. Push to the branch (`git push origin feature/amazing-feature`)\n5. Create a new Pull Request","ref":"readme.html#contributing"},{"type":"extras","title":"License - ExEcrime","doc":"This project is licensed under the BSD 3-Clause License - see the LICENSE file for details.","ref":"readme.html#license"},{"type":"extras","title":"Contact - ExEcrime","doc":"For issues or questions, please file an issue on the GitHub repository.","ref":"readme.html#contact"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}